REM JGVIS 2.1b
REM (2.1, 2.1a and 2.1b have exactly the same functions)
REM this program was created with a Basic compiler with just GOSUB.
REM I didn't feel like rewriting it for an intensive use of SUB of FUNCTION ;)
OPTION BASE 1
DEFSTR A
DEFINT I
DEFLNG L
DEFDBL D
DEFSNG S

REM JG table; 99 elements addressed directly by ID#
REM I loose memory (JGs are 40 max), but the program is really simplified
REM Race field has two index; it stores ship ID# which discovers the JG

REM .-------------------------------------------------.
REM | Owner | X | Y | Feds | Lizards | ... | Colonies |
REM +-------+---+---+------+---------+-----+----------+
REM |       |   |   |      |         |     |          | Element 1 (ie JG01)
REM +-------+---+---+------+---------+-----+----------+
REM |       |   |   |      |         |     |          | Element 2
REM +-------+---+---+------+---------+-----+----------+
REM ...................................................
REM +-------+---+---+------+---------+-----+----------+
REM |       |   |   |      |         |     |          | Element 99
REM '-------------------------------------------------'
DIM iJGRace(99)
DIM iJGX(99)
DIM iJGY(99)
DIM iJGRaceVis(99, 11)

REM Simply they are the famous 500-ship slots ;) with owner and coords
DIM iSHRace(500)
DIM iSHX(500)
DIM iSHY(500)

REM UFO archive
TYPE UfoRcd
   iMarker AS INTEGER
   aNm AS STRING * 20
   aInfo1 AS STRING * 20
   aInfo2 AS STRING * 20
   iX AS INTEGER
   iY AS INTEGER
   iWarp AS INTEGER
   iHeading AS INTEGER
   iRangeP AS INTEGER
   iRangeS AS INTEGER
   iEdge AS INTEGER
   iParent AS INTEGER
END TYPE

REM Ship coords
TYPE ShipxyRcd
  iX AS INTEGER
  iY AS INTEGER
  iRace AS INTEGER
  iMass AS INTEGER
END TYPE

REM Msg pointer
TYPE MessPntRcd
     iRace AS INTEGER
     lOffset AS LONG
     iLenght AS INTEGER
END TYPE

REM Jump Gate configuration file
TYPE JGConfigRcd
     iJGNbr AS INTEGER
     iDamage AS INTEGER
     sLost AS SINGLE
     iRange AS INTEGER
     iAlien AS INTEGER
     iSwCloaked AS INTEGER
     iSwGravitonic AS INTEGER
     iSwAncient AS INTEGER
     iAlientOdd AS INTEGER
     iSwAlien AS INTEGER
     iGas AS INTEGER
     iTr AS INTEGER
     iDu AS INTEGER
     iMo AS INTEGER
     iSu AS INTEGER
END TYPE

DIM uUfo     AS UfoRcd
DIM uShipxy  AS ShipxyRcd
DIM uMessPnt AS MessPntRcd
DIM uJGConfig AS JGConfigRcd

CONST aRel = "JGVIS 2.1b"
CONST aAuthor = "Paolo Fiore (Italy)"
CONST aUfoDB$ = "UFO.HST"
CONST aShipDB$ = "SHIPXY.HST"
CONST aLogDB$ = "JGVIS.LOG"
CONST aMsgDB$ = "MESS.EXT"
CONST aMsgPntDB$ = "MESSPNT.EXT"
CONST aJGConfigDB$ = "JGCONFIG.HST"

aCR = CHR$(13)
aLF = CHR$(10)
aCRLF = aCR + aLF

REM --------------------- well, enjoy yourself -------------------

ON ERROR GOTO Generico:

REM I force a msg for JG01 to all races
FOR iInd = 1 TO 11
    iJGRaceVis(1, iInd) = 999
NEXT iInd

REM I immediately store the command line with game path
aPathDB = COMMAND$
aPathDB = RTRIM$(aPathDB)

REM if needed I insert final slash
IF RIGHT$(aPathDB, 1) <> "\" THEN
   aPathDB = aPathDB + "\"
END IF

REM log file opened until program finish
aNomeDB = aPathDB + aLogDB
ON ERROR GOTO ErrOK:
KILL aNomeDB
ON ERROR GOTO Generico:
OPEN aNomeDB FOR OUTPUT AS #3

GOSUB StampaLog:
aTemp = STRING$(20, "-") + "  " + aRel + "  " + STRING$(24, "-")
GOSUB StampaLog:
GOSUB StampaLog:
aTemp = "   Give Jump Gate Visibility to your DOS VGAP Clients"
GOSUB StampaLog:
aTemp = "         Public Domain by P.Fiore & JMC (Italy)"
GOSUB StampaLog:
GOSUB StampaLog:
aTemp = STRING$(57, "-")
GOSUB StampaLog:
iSwStampa = 1
aTemp = " " + DATE$ + " - " + TIME$
GOSUB StampaLog:
GOSUB StampaLog:

REM here I look for visibility range into JG configuration file
REM if not found I suppose there's no JG addon and go out
aNomeDB = aPathDB + aJGConfigDB
ON ERROR GOTO ErrJGConfig:
OPEN aNomeDB FOR INPUT AS #1
ON ERROR GOTO Generico:
CLOSE #1

OPEN aNomeDB FOR BINARY AS #1
GET #1, , uJGConfig
CLOSE #1
iVisibility = uJGConfig.iRange

REM ok, I open UFO archive and start JG elaboration
aNomeDB = aPathDB + aUfoDB
aTemp = " Digesting " + aNomeDB
GOSUB StampaLog:
OPEN aNomeDB FOR BINARY AS #1
GOSUB ElabJG:
CLOSE 1

REM here is ships processing
aNomeDB = aPathDB + aShipDB
aTemp = " Digesting " + aNomeDB
GOSUB StampaLog:
OPEN aNomeDB FOR BINARY AS #1
GOSUB ElabShips:
CLOSE 1

REM I write on log file total amounts for JGs and ships
aTemp = " Total jump gate evaluated:" + STR$(iJGTot)
iSwStampa = 1
GOSUB StampaLog:
aTemp = " Total ships evaluated:" + STR$(iSHTot)
iSwStampa = 1
GOSUB StampaLog:

REM this is the core ;) for each ship I check if it makes a JG visible
REM (using direct indexes I obviously have records to reject (owner=zero)
aTemp = " Figuring out visibility; range considered" + STR$(iVisibility) + "LY"
GOSUB StampaLog:
FOR iSH = 1 TO 500
    FOR iJG = 1 TO 99
       IF iSHRace(iSH) > 0 THEN
          IF iJGRace(iJG) > 0 THEN
             GOSUB Calcola:
          END IF
       END IF
    NEXT iJG
NEXT iSH

REM logging JG table which is ready now
aNomeDB = aPathDB + aLogDB
PRINT " Logging table in " + aNomeDB
GOSUB PrintaTab:

REM well, we are ready to send VGAP messages
aTemp = " Processing messages in MESS/MESSPNT.EXT"
GOSUB StampaLog:

aMessPnt = aPathDB + aMsgPntDB
aMess = aPathDB + aMsgDB
GOSUB Testata:

REM JG loop
FOR iJG = 1 TO 99
    IF iJGRace(iJG) > 0 THEN
       REM races loop... and we have now two index
       REM at last if there is visibility I send the msg
       FOR iInd = 1 TO 11
           IF iJGRaceVis(iJG, iInd) <> 0 THEN
              GOSUB Messaggio:
           END IF
       NEXT iInd
    END IF
NEXT iJG

REM I write on log file total number of sent msgs
aTemp = " Total sent messages:" + STR$(iTotSentMsg)
iSwStampa = 1
GOSUB StampaLog:


REM I have to jump error routines
GOTO fine:

REM --------------------------------------------------------------
ErrOK:
REM all ok ;) I need to go ahead (e.g. new files and so on)
iErrResume = ERR
RESUME NEXT

REM --------------------------------------------------------------
ErrJGConfig:
REM There's no JG configuration, simply go to exit
aTemp = " Jump Gate configuration does not exist,"
GOSUB StampaLog:
aTemp = " no reasons to run JGVIS"
GOSUB StampaLog:

GOTO fine:

REM --------------------------------------------------------------
Generico:
REM this is a real error I never considered.
REM Should be I'm not so good as I think? ;))))
PRINT "*** Unrecoverable Error: "; ERR; ERL

fine:
PRINT " "
PRINT STRING$(57, "-")

END


REM **********************  ROUTINES   ************************

REM --------------------------------------------------------------
StampaLog:
REM Prints on screen and on logs file the variable aTemp I previously prepared
REM if iSwStampa = 1 jump the screen

IF iSwStampa = 0 THEN
   PRINT aTemp
END IF
iSwStampa = 0
REM aTemp = aTemp + aCRLF
PRINT #3, aTemp
aTemp = " "
RETURN

REM --------------------------------------------------------------
ElabJG:
REM UFO files opened; I process all its records
REM this is the classical "out-of-loop read"

GET #1, , uUfo

DO WHILE NOT EOF(1)

REM these are the records we are concerned
IF INSTR(uUfo.aNm, "Jump Gate") <> 0 THEN

   iJGTot = iJGTot + 1
   IF RTRIM$(uUfo.aNm) = "Jump Gate" THEN
      GOSUB ElabInfo2:
   ELSE
      iJG = 1
      iJGRace(iJG) = 99
   END IF

   iJGX(iJG) = uUfo.iX
   iJGY(iJG) = uUfo.iY
END IF

REM and here is the read which will generate end of file
GET #1, , uUfo
LOOP

RETURN

REM --------------------------------------------------------------
ElabInfo2:
REM Owner and ID are in one string; I retrieve them
REM e.g. "JG ID: 7 Owner: 5" (RTRIM$ removes right blanks)

aTemp = RTRIM$(MID$(uUfo.aInfo2, 8, 2))
iSwJG = LEN(aTemp)
iJG = VAL(aTemp)

REM I need to check if how much ID is long and to shift owner consequently
IF iSwJG = 2 THEN
   aTemp = MID$(uUfo.aInfo2, 18, 2)
ELSE
   aTemp = MID$(uUfo.aInfo2, 17, 2)
END IF
iJGRace(iJG) = VAL(RTRIM$(aTemp))

RETURN

REM --------------------------------------------------------------
ElabShips:
REM there are exactly 500 records which contain owner (if exist) and coords

FOR iInd = 1 TO 500
   GET #1, , uShipxy
   IF uShipxy.iRace > 0 THEN
      iSHTot = iSHTot + 1
      iSHX(iInd) = uShipxy.iX
      iSHY(iInd) = uShipxy.iY
      iSHRace(iInd) = uShipxy.iRace
   END IF
NEXT iInd

RETURN

REM --------------------------------------------------------------
Calcola:
REM it will be visible or not?
REM here below the square in which ship must be
iJGXMeno = iJGX(iJG) - iVisibility
iJGYMeno = iJGY(iJG) - iVisibility
iJGXPiu = iJGX(iJG) + iVisibility
iJGYPiu = iJGY(iJG) + iVisibility

REM out of square; I go out
IF iSHX(iSH) < iJGXMeno THEN GOTO NoVis:
IF iSHX(iSH) > iJGXPiu THEN GOTO NoVis:
IF iSHY(iSH) < iJGYMeno THEN GOTO NoVis:
IF iSHY(iSH) > iJGYPiu THEN GOTO NoVis:

REM I set visibility to right race in JG table (starting from ship owner).
REM e.g. iJGRaceVis(21, 11)) = 423 that is
REM the colonies has visibility on JG 21 thanks to their ship ID 423

iJGRaceVis(iJG, iSHRace(iSH)) = iSH

NoVis:
RETURN

REM --------------------------------------------------------------
PrintaTab:
REM simply prints JG table;
REM (there might be a better method to allign fields, but I do not know it :()

iSwStampa = 1
GOSUB StampaLog
aTemp = " JG Owner  1    2    3    4    5    6    7"
aTemp = aTemp + "    8    9    A    B" + aCRLF

iSwStampa = 1
GOSUB StampaLog

REM typical loop to access to JG table
FOR iJG = 1 TO 99
    IF iJGRace(iJG) <> 0 THEN
       REM I manage alignment inserting blanks (strings have a leading blank)
       aTemp = STR$(iJG)
       IF LEN(STR$(iJG)) = 2 THEN
          aTemp = SPACE$(1) + aTemp
       END IF
      
       IF LEN(STR$(iJGRace(iJG))) = 2 THEN
          aTemp = aTemp + SPACE$(3)
       ELSE
          aTemp = aTemp + SPACE$(2)
       END IF
       aTemp = aTemp + STR$(iJGRace(iJG))

       FOR iInd = 1 TO 11
           SELECT CASE LEN(STR$(iJGRaceVis(iJG, iInd)))
              CASE IS = 2
                   aTemp = aTemp + SPACE$(3)
              CASE IS = 3
                   aTemp = aTemp + SPACE$(2)
              CASE IS = 4
                   aTemp = aTemp + SPACE$(1)
           END SELECT
           aTemp = aTemp + STR$(iJGRaceVis(iJG, iInd))
       NEXT iInd
       iSwStampa = 1
       GOSUB StampaLog:

    END IF
NEXT iJG

iSwStampa = 1
GOSUB StampaLog
RETURN

REM --------------------------------------------------------------
Testata:
REM Initial msg; sent to all races (commercial ;))

aMessaggio = "<<< Jump Gate Visibility >>>" + aCR + aCR
aMessaggio = aMessaggio + ">>>  " + aRel + "  <<<" + aCR
aMessaggio = aMessaggio + SPACE$(3) + "Public Domain" + aCR + aCR
aMessaggio = aMessaggio + "Enemy Jump Gates" + aCR
aMessaggio = aMessaggio + "are no longer invisible to DOS Clients" + aCR + aCR
aMessaggio = aMessaggio + "Opponent's 'short cuts' will be visible" + aCR
aMessaggio = aMessaggio + "if not beyond" + STR$(iVisibility) + "LY far away a ship of us" + aCR + aCR
aMessaggio = aMessaggio + "thanks to P.Fiore & JMC"

GOSUB Cripta:

FOR iInd = 1 TO 11
    GOSUB ComuneMsg:
NEXT iInd

RETURN

REM --------------------------------------------------------------
Messaggio:
REM I've visibility; I shoot a msg to the involved race

aMessaggio = "<<< Jump Gate Details >>>" + aCR + aCR + aCR

IF iJG = 1 THEN
   aMessaggio = aMessaggio + "From: ship ID# " + STR$(iJGRaceVis(iJG, iInd)) + aCR + aCR
   aMessaggio = aMessaggio + "Your host has configured the Ancient" + aCR
   aMessaggio = aMessaggio + ">>>  ID# " + STR$(iJG) + "  <<<" + aCR + aCR
   aMessaggio = aMessaggio + "It is steadly located "
   aMessaggio = aMessaggio + "at (" + STR$(iJGX(iJG)) + "," + STR$(iJGY(iJG)) + ")" + aCR + aCR
   aMessaggio = aMessaggio + "and it cannot be destroyed in any way!"
ELSE
   aMessaggio = aMessaggio + "From: ship ID# " + STR$(iJGRaceVis(iJG, iInd)) + aCR + aCR
   aMessaggio = aMessaggio + "We have flushed out another Jump Gate" + aCR
   aMessaggio = aMessaggio + ">>>  ID# " + STR$(iJG) + "  <<<" + aCR + aCR
   aMessaggio = aMessaggio + "It seems to be located "
   aMessaggio = aMessaggio + "at (" + STR$(iJGX(iJG)) + "," + STR$(iJGY(iJG)) + ")" + aCR + aCR
   aMessaggio = aMessaggio + "Reliable source assures us" + aCR
   aMessaggio = aMessaggio + "it was created by race: " + STR$(iJGRace(iJG))
END IF

GOSUB Cripta:

iTotSentMsg = iTotSentMsg + 1
GOSUB ComuneMsg:

RETURN

REM --------------------------------------------------------------
Cripta:
REM security ;) simply add 13 to SCII code.

FOR iInd2 = 1 TO LEN(aMessaggio)
    aTemp = CHR$(ASC(MID$(aMessaggio, iInd2, 1)) + 13)
    MID$(aMessaggio, iInd2, 1) = aTemp
NEXT iInd2

RETURN


REM --------------------------------------------------------------
ComuneMsg:
REM output routine for prepared msg (aMessaggio)
REM if file doesn't exist "open for binary" creates it empty

OPEN aMess FOR BINARY AS #1

REM lMessStart contains the first byte of the new msg
REM    (I need it for PUT and for MESSPNT file)
REM lMessEnd will be a switch too
lMessLenght = LOF(1)
lMessStart = lMessLenght + 1

REM I write the msg using lMessStart as starting byte in random PUT
PUT #1, lMessStart, aMessaggio
CLOSE #1

iSwKill = 0
IF lMessLenght = 0 THEN
   REM MESS didn't exist, I delete MESSPNT (trapping error)
   ON ERROR GOTO ErrOK:
   KILL aMessPnt
   ON ERROR GOTO Generico:
END IF

OPEN aMessPnt FOR BINARY AS #1
REM if I previously deleted the file I need to skip the read
IF lMessLenght <> 0 THEN
   GET #1, , iTotMsg
END IF

REM each record is: 8byte + 2 for the first msg counter
REM I add one since I will use it to point to the first usefull byte
lMessPntStart = (iTotMsg * 8) + 2 + 1

REM rewrite the total including the new msg
iTotMsg = iTotMsg + 1
PUT #1, 1, iTotMsg

REM I jump to the first usefull byte and insert a new header record
SEEK #1, lMessPntStart
uMessPnt.iRace = iInd
uMessPnt.lOffset = lMessStart
uMessPnt.iLenght = LEN(aMessaggio)
PUT #1, , uMessPnt

CLOSE #1
RETURN

